// Definitions from P16F877.INC
// Converted using inc2h v1.0, by John Nagle (http://www.jobie.com)

//=============================================
// PART = PIC 16F877


#define         W               0x0000                                                                                         
#define         F               0x0001                                                                                         

//=============================================
// Registers

char indf@0x0000;
char tmr0@0x0001;
char pcl@0x0002;
char status@0x0003;
char fsr@0x0004;
char porta@0x0005;
char portb@0x0006;
char portc@0x0007;
char portd@0x0008;
char porte@0x0009;
char pclath@0x000A;
char intcon@0x000B;
char pir1@0x000C;
char pir2@0x000D;
char tmr1l@0x000E;
char tmr1h@0x000F;
char t1con@0x0010;
char tmr2@0x0011;
char t2con@0x0012;
char sspbuf@0x0013;
char sspcon@0x0014;
char ccpr1l@0x0015;
char ccpr1h@0x0016;
char ccp1con@0x0017;
char rcsta@0x0018;
char txreg@0x0019;
char rcreg@0x001A;
char ccpr2l@0x001B;
char ccpr2h@0x001C;
char ccp2con@0x001D;
char adresh@0x001E;
char adcon0@0x001F;
char option_reg@0x0081;
char trisa@0x0085;
char trisb@0x0086;
char trisc@0x0087;
char trisd@0x0088;
char trise@0x0089;
char pie1@0x008C;
char pie2@0x008D;
char pcon@0x008E;
char sspcon2@0x0091;
char pr2@0x0092;
char sspadd@0x0093;
char sspstat@0x0094;
char txsta@0x0098;
char spbrg@0x0099;
char adresl@0x009E;
char adcon1@0x009F;
char eedata@0x010C;
char eeadr@0x010D;
char eedath@0x010E;
char eeadrh@0x010F;
char eecon1@0x018C;
char eecon2@0x018D;

//=============================================
// STATUS Bits

#define         IRP             0x0007                                                                                         
#define         RP1             0x0006                                                                                         
#define         RP0             0x0005                                                                                         
#define         NOT_TO          0x0004                                                                                         
#define         NOT_PD          0x0003                                                                                         
#define         Z               0x0002                                                                                         
#define         DC              0x0001                                                                                         
#define         C               0x0000                                                                                         

//=============================================
// INTCON Bits

#define         GIE             0x0007                                                                                         
#define         PEIE            0x0006                                                                                         
#define         T0IE            0x0005                                                                                         
#define         INTE            0x0004                                                                                         
#define         RBIE            0x0003                                                                                         
#define         T0IF            0x0002                                                                                         
#define         INTF            0x0001                                                                                         
#define         RBIF            0x0000                                                                                         

//=============================================
// PIR1 Bits

#define         PSPIF           0x0007                                                                                         
#define         ADIF            0x0006                                                                                         
#define         RCIF            0x0005                                                                                         
#define         TXIF            0x0004                                                                                         
#define         SSPIF           0x0003                                                                                         
#define         CCP1IF          0x0002                                                                                         
#define         TMR2IF          0x0001                                                                                         
#define         TMR1IF          0x0000                                                                                         

//=============================================
// PIR2 Bits

#define         EEIF            0x0004                                                                                         
#define         BCLIF           0x0003                                                                                         
#define         CCP2IF          0x0000                                                                                         

//=============================================
// T1CON Bits

#define         T1CKPS1         0x0005                                                                                         
#define         T1CKPS0         0x0004                                                                                         
#define         T1OSCEN         0x0003                                                                                         
#define         NOT_T1SYNC      0x0002                                                                                         
#define         T1INSYNC        0x0002                                                                                         
#define         T1SYNC          0x0002                                                                                         
#define         TMR1CS          0x0001                                                                                         
#define         TMR1ON          0x0000                                                                                         

//=============================================
// T2CON Bits

#define         TOUTPS3         0x0006                                                                                         
#define         TOUTPS2         0x0005                                                                                         
#define         TOUTPS1         0x0004                                                                                         
#define         TOUTPS0         0x0003                                                                                         
#define         TMR2ON          0x0002                                                                                         
#define         T2CKPS1         0x0001                                                                                         
#define         T2CKPS0         0x0000                                                                                         

//=============================================
// SSPCON Bits

#define         WCOL            0x0007                                                                                         
#define         SSPOV           0x0006                                                                                         
#define         SSPEN           0x0005                                                                                         
#define         CKP             0x0004                                                                                         
#define         SSPM3           0x0003                                                                                         
#define         SSPM2           0x0002                                                                                         
#define         SSPM1           0x0001                                                                                         
#define         SSPM0           0x0000                                                                                         

//=============================================
// CCP1CON Bits

#define         CCP1X           0x0005                                                                                         
#define         CCP1Y           0x0004                                                                                         
#define         CCP1M3          0x0003                                                                                         
#define         CCP1M2          0x0002                                                                                         
#define         CCP1M1          0x0001                                                                                         
#define         CCP1M0          0x0000                                                                                         

//=============================================
// RCSTA Bits

#define         SPEN            0x0007                                                                                         
#define         RX9             0x0006                                                                                         
#define         RC9             0x0006                                                                                         
#define         NOT_RC8         0x0006                                                                                         
#define         RC8_9           0x0006                                                                                         
#define         SREN            0x0005                                                                                         
#define         CREN            0x0004                                                                                         
#define         ADDEN           0x0003                                                                                         
#define         FERR            0x0002                                                                                         
#define         OERR            0x0001                                                                                         
#define         RX9D            0x0000                                                                                         
#define         RCD8            0x0000                                                                                         

//=============================================
// CCP2CON Bits

#define         CCP2X           0x0005                                                                                         
#define         CCP2Y           0x0004                                                                                         
#define         CCP2M3          0x0003                                                                                         
#define         CCP2M2          0x0002                                                                                         
#define         CCP2M1          0x0001                                                                                         
#define         CCP2M0          0x0000                                                                                         

//=============================================
// ADCON0 Bits

#define         ADCS1           0x0007                                                                                         
#define         ADCS0           0x0006                                                                                         
#define         CHS2            0x0005                                                                                         
#define         CHS1            0x0004                                                                                         
#define         CHS0            0x0003                                                                                         
#define         GO              0x0002                                                                                         
#define         NOT_DONE        0x0002                                                                                         
#define         GO_DONE         0x0002                                                                                         
#define         ADON            0x0000                                                                                         

//=============================================
// OPTION_REG Bits

#define         NOT_RBPU        0x0007                                                                                         
#define         INTEDG          0x0006                                                                                         
#define         T0CS            0x0005                                                                                         
#define         T0SE            0x0004                                                                                         
#define         PSA             0x0003                                                                                         
#define         PS2             0x0002                                                                                         
#define         PS1             0x0001                                                                                         
#define         PS0             0x0000                                                                                         

//=============================================
// TRISE Bits

#define         IBF             0x0007                                                                                         
#define         OBF             0x0006                                                                                         
#define         IBOV            0x0005                                                                                         
#define         PSPMODE         0x0004                                                                                         
#define         TRISE2          0x0002                                                                                         
#define         TRISE1          0x0001                                                                                         
#define         TRISE0          0x0000                                                                                         

//=============================================
// PIE1 Bits

#define         PSPIE           0x0007                                                                                         
#define         ADIE            0x0006                                                                                         
#define         RCIE            0x0005                                                                                         
#define         TXIE            0x0004                                                                                         
#define         SSPIE           0x0003                                                                                         
#define         CCP1IE          0x0002                                                                                         
#define         TMR2IE          0x0001                                                                                         
#define         TMR1IE          0x0000                                                                                         

//=============================================
// PIE2 Bits

#define         EEIE            0x0004                                                                                         
#define         BCLIE           0x0003                                                                                         
#define         CCP2IE          0x0000                                                                                         

//=============================================
// PCON Bits

#define         NOT_POR         0x0001                                                                                         
#define         NOT_BO          0x0000                                                                                         
#define         NOT_BOR         0x0000                                                                                         

//=============================================
// SSPCON2 Bits

#define         GCEN            0x0007                                                                                         
#define         ACKSTAT         0x0006                                                                                         
#define         ACKDT           0x0005                                                                                         
#define         ACKEN           0x0004                                                                                         
#define         RCEN            0x0003                                                                                         
#define         PEN             0x0002                                                                                         
#define         RSEN            0x0001                                                                                         
#define         SEN             0x0000                                                                                         

//=============================================
// SSPSTAT Bits

#define         SMP             0x0007                                                                                         
#define         CKE             0x0006                                                                                         
#define         D               0x0005                                                                                         
#define         I2C_DATA        0x0005                                                                                         
#define         NOT_A           0x0005                                                                                         
#define         NOT_ADDRESS     0x0005                                                                                         
#define         D_A             0x0005                                                                                         
#define         DATA_ADDRESS    0x0005                                                                                         
#define         P               0x0004                                                                                         
#define         I2C_STOP        0x0004                                                                                         
#define         S               0x0003                                                                                         
#define         I2C_START       0x0003                                                                                         
#define         R               0x0002                                                                                         
#define         I2C_READ        0x0002                                                                                         
#define         NOT_W           0x0002                                                                                         
#define         NOT_WRITE       0x0002                                                                                         
#define         R_W             0x0002                                                                                         
#define         READ_WRITE      0x0002                                                                                         
#define         UA              0x0001                                                                                         
#define         BF              0x0000                                                                                         

//=============================================
// TXSTA Bits

#define         CSRC            0x0007                                                                                         
#define         TX9             0x0006                                                                                         
#define         NOT_TX8         0x0006                                                                                         
#define         TX8_9           0x0006                                                                                         
#define         TXEN            0x0005                                                                                         
#define         SYNC            0x0004                                                                                         
#define         BRGH            0x0002                                                                                         
#define         TRMT            0x0001                                                                                         
#define         TX9D            0x0000                                                                                         
#define         TXD8            0x0000                                                                                         

//=============================================
// ADCON1 Bits

#define         ADFM            0x0007                                                                                         
#define         PCFG3           0x0003                                                                                         
#define         PCFG2           0x0002                                                                                         
#define         PCFG1           0x0001                                                                                         
#define         PCFG0           0x0000                                                                                         

//=============================================
// EECON1 Bits

#define         EEPGD           0x0007                                                                                         
#define         WRERR           0x0003                                                                                         
#define         WREN            0x0002                                                                                         
//#define         WR              0x0001                                                                                         
//#define         RD              0x0000                                                                                         

//=============================================
// Configuration Bits

#define         _CP_ALL         0x0FCF                                                                                         
#define         _CP_HALF        0x1FDF                                                                                         
#define         _CP_UPPER_256   0x2FEF                                                                                         
#define         _CP_OFF         0x3FFF                                                                                         
#define         _DEBUG_ON       0x37FF                                                                                         
#define         _DEBUG_OFF      0x3FFF                                                                                         
#define         _WRT_ENABLE_ON  0x3FFF                                                                                         
#define         _WRT_ENABLE_OFF 0x3DFF                                                                                         
#define         _CPD_ON         0x3EFF                                                                                         
#define         _CPD_OFF        0x3FFF                                                                                         
#define         _LVP_ON         0x3FFF                                                                                         
#define         _LVP_OFF        0x3F7F                                                                                         
#define         _BODEN_ON       0x3FFF                                                                                         
#define         _BODEN_OFF      0x3FBF                                                                                         
#define         _PWRTE_OFF      0x3FFF                                                                                         
#define         _PWRTE_ON       0x3FF7                                                                                         
#define         _WDT_ON         0x3FFF                                                                                         
#define         _WDT_OFF        0x3FFB                                                                                         
#define         _LP_OSC         0x3FFC                                                                                         
#define         _XT_OSC         0x3FFD                                                                                         
#define         _HS_OSC         0x3FFE                                                                                         
#define         _RC_OSC         0x3FFF                                                                                         
//=============================================
// Configuration Bits

#define         P7              0x0007                                                                                        
#define         P6              0x0006                                                                                       
#define         P5              0x0005                                                                                    
#define         P4              0x0004                                                                                        
#define         P3              0x0003                                                                                        
#define         P2              0x0002                                                                                         
#define         P1              0x0001                                                                                         
#define         P0              0x0000                                                                                         
                                                                                    
                                                                              
//******************************************************************
//*	RTL8019AS REG DEFINITION
//******************************************************************

#define CR		 	0x00
#define PSTART		0x01
#define PAR0        0x01    // Page 1
#define CR9346      0x01    // Page 3
#define PSTOP		0x02
#define BNRY		0x03
#define TSR			0x04
#define TPSR		0x04
#define TBCR0		0x05
#define NCR			0x05
#define TBCR1		0x06
#define ISR			0x07
#define CURR		0x07   // Page 1
#define RSAR0		0x08
#define CRDA0		0x08
#define RSAR1		0x09
#define CRDAL		0x09
#define RBCR0		0x0A
#define RBCR1		0x0B
#define RSR			0x0C
#define RCR			0x0C
#define TCR			0x0D
#define CNTR0		0x0D
#define DCR			0x0E
#define CNTR1		0x0E
#define IMR			0x0F
#define CNTR2		0x0F
#define RDMAPORT    0X10
#define RSTPORT     0x18

//******************************************************************
//*	RTL8019AS INITIAL REGISTER VALUES
//******************************************************************
#define rcrval		0x04
#define tcrval		0x00
#define dcrval		0x58    // was 0x48
#define imrval		0x11    // PRX and OVW interrupt enabled
#define txstart     0x40
#define rxstart     0x50  //0x46
#define rxstop      0xA0

//Ethernet Communication 
#define PACKET_SIZE 89 
#define PREAMBLE_SIZE 10 
#define TYPECODE_OFFSET 10	
#define OPCODE_OFFSET 11
#define COUNT_OFFSET_OFFSET 12
#define DATA_OFFSET 13 
#define MAC_ADDR_OFFSET 6
#define HEADER_OFFSET 9

#define DATA_TYPE_MASK     0x0f 
#define MAX_TICK           0x00 
#define PRESCALER          0x01 	
#define ENDIAN             0x02 // 0 : for PC, 1 for MAC
#define DEBUG_FLAG1        0x03  
#define DEBUG_FLAG2		   0x04
#define CURR_AVG           0x05
#define VOLTAGE            0x06
#define CURRENT            0x07
#define TIME               0x08

#define    COMM_TYPE_MASK 0xf0
#define	SEND	0x80
#define	RECV	0x00
#define    SEND_RECV_MASK 0x80
#define	ACK	0x40
#define	NOACK	0x00
#define    ACK_NOACK_MASK 0x40
#define	STOP	0x20
#define	CONTINUE	0x00
#define    STOP_CONTINUE_MASK 0x20
#define VREFADC_INDEX_MASK 0x09
#define VREF_5 0x00
#define VREF_4 0x01

#define   MEASURE_VOLTAGE 0x80
#define   MEASURE_VOLTAGE_MASK 0x80
#define   MEASURE_CURRENT_MASK 0x40
#define   MEASURE_CURRENT 0x40
#define   EMULATE_VOLTAGE 0x10
#define   EMULATE_VOLTAGE_MASK 0x10
#define   MEASURE_AVG_CURRENT 0x20
#define   MEASURE_AVG_CURRENT_MASK 0x20
#define   NOP 0x00


#define VOLTT   0xa1 //| 10 100 001 | // 
#define CURRR   0x89 //| 10 001 001 | //



#define CH_1_X   0x81 //| 10 000 001 | // 
#define CH_1_Y   0x89 //| 10 001 001 | //
#define CH_2_X   0x91 //| 10 010 001 | // 
#define CH_2_Y   0x99 //| 10 011 001 | //
#define CH_3_X   0xa1 //| 10 100 001 | // 
#define CH_3_Y   0xa9 //| 10 101 001 | //
#define CH_4_X   0xb1 //| 10 110 001 | // 
#define CH_4_Y   0xb9 //| 10 111 001 | //




