#include    <p16f877l.h>

#define DEBUG 0

//=============================================================
//
void run_led(void);
void logo(void);
//=============================================================
//Serial communication
void serial_init(void);
void putch(char c);
char getch(void);
void putchhex(char c);
void putst(const char * str);

//=============================================================
//Utilities
char read_bit(char reg,char offset);
void DelayMs(int x);
void DelayUs(int x);
//=============================================================
//SPI
#define TURNON 0xFF
#define TURNOFF 0x00
void spi_init(void);
void dac_out(char data_H, char data_L);
void regulator_init();
void regulator(char status);
//=============================================================
//Ethernet
char endian;
char txlen,rxlen; //STRANGE!!!!!!
char typecode,opcode,packet_count;
char data_type,send_recv,ack_noack;
char packet[PACKET_SIZE];  
char byte_read;
void write_creg(char regaddr, char regdata);
char read_creg(char regaddr);
void init_RTL8019AS();
void send(char size);
char get_packet(void);
void receive(void);
void show_packet(char size);
void exchange_data(void);
void receive_packet(void);
void send_packet(void);
char com_flag,send_flag;
//==============================================================
//Operation
#define MAX_POINT 80
char time[MAX_POINT];
char volt[MAX_POINT];
char interval,prescaler,vref;
int num;
//char crnt[CUR_POINT];
char data_H,data_L;
int  current = 0;
void ad_check(void);
void adc_init(void);
void ad_convert(char type);
void cur_average(void);
void currsensor(char status);
int t;
int global_tick =  0;
int local_tick =   0;
void int_init(void);
void interrupt(void);
char data_len;
void main()
{
    char temp,t,k,l,t_time;
    
    serial_init();
    logo(); 
    spi_init();
    regulator_init();
    init_RTL8019AS();
    run_led();
    adc_init();
    int_init();
    regulator(TURNON);
    #if DEBUG
    for(t=0; t < MAX_POINT; t++){
      time[t] = t;
      volt[t] = t;
    }
    for (t = 6; t < PACKET_SIZE; t++){
			packet[t] = 0x00;
	}
    #endif
    for (t = 0; t < 6; t++){
			packet[t] = 0x01;
	}
	interval = 60;
	endian = 0;
	//dac_out(0x01,0xfc);
	dac_out(0x05,0x00);
	opcode = 0x00;
	currsensor(TURNON);
	/*
	for (t=0 ; t < 5 ; t++){
		t = 3;
		ad_convert(CURRR);
		putchhex(data_H);
		putchhex(data_L);
		putst("\r\n");
		DelayMs(1);
	}
	*/
	while(1)//continuous loop
	{  
		exchange_data();
		//timer on
		int_init();
		temp = opcode & EMULATE_VOLTAGE_MASK;
		
		
		if ( temp == EMULATE_VOLTAGE ){
		
			//putst("\r\nVoltage Emulate & Current Measure CMD is executing!\r\n");
		
			temp = opcode & MEASURE_AVG_CURRENT_MASK;
			num = data_len / 2;
			for (t = 0 ; t < num; t++)
			{
				if (endian == 1){ //MAC
					data_H = volt[2*t]; 
					data_L = volt[2*t+1];
				}else{
					data_L = volt[2*t]; 
					data_H = volt[2*t+1];
				}
				dac_out(data_H,data_L);
				//putst("Volt Output!!\r\n");
				
				if (temp == MEASURE_AVG_CURRENT){
					ad_convert(CURRR);
					volt[2*t] = data_H; 
					volt[2*t+1]= data_L;
					//putst("Measure a Current Value\r\n");
					//putchhex(data_H);
					//putchhex(data_L);
					//putst("\r\n");
				}
				
				k = t + 1;
				l = 2*k;
				if ( l < data_len){
					t_time = time[l + endian]; 
			    
					enable_interrupt( GIE );
					enable_interrupt( T0IE );
				
					while(t_time > local_tick)
					{	
						;;
					}
					local_tick = 0;
				}
				#if DEBUG
				putst("\r\nTICK \r\n");
				#endif
			}
			clear_bit( intcon, GIE );
		    clear_bit( intcon, T0IE );
			cur_average();
			#if 1
			//putst("\r\n\nEmulation has finished!! \r\n");
			#endif
		}
		
		if ( opcode == 0xC0 ){
		#if DEBUG
		putst("\r\nVoltage Measure &  Measure CMD is executing!\r\n");
		#endif
			//enable_interrupt( GIE );
			//enable_interrupt( T0IE );
			//k = interval + 1;
			//while ( global_tick < k )
			//{
			//	num = (global_tick - 1) * 2;
			//	num = 0;
			//	temp = global_tick;
				packet[MAC_ADDR_OFFSET + 0] = CURRENT; 
				packet[MAC_ADDR_OFFSET + 1] = 0x00;
				packet[MAC_ADDR_OFFSET + 2] = 4;
			while(1){
				
				ad_convert(CURRR);
				//if (endian == 1){
				//	time[num] = data_H;
				//	time[num + 1] = data_L;
				//}else{
				//	time[num] = data_L;
				//	time[num + 1] = data_H;
				//}
				//putchhex(data_H);
				//putchhex(data_L);
				//putst("\r\n");
				packet[HEADER_OFFSET + 2] = data_L;
				packet[HEADER_OFFSET + 3] = data_H;
				DelayMs(1); //debug
				ad_convert(VOLTT);
				//if (endian == 1){
				//	volt[num] = data_H;
				//	volt[num + 1] = data_L;
				//}else{
				//	volt[num] = data_L;
				//	volt[num + 1] = data_H;
				//}
				packet[HEADER_OFFSET + 0] = data_L;
				packet[HEADER_OFFSET + 1] = data_H;
				send(4);
				//putst("SENT!!\r\n");
			}
				//while (temp == global_tick){
				//	nop();
				//}
			//}
			
			#if DEBUG
			//putst("\r\n\nMeasuring has finished!! \r\n");
			#endif
		}	
		global_tick = 0;
	}
}

void interrupt( void )
{
   global_tick = global_tick + 1;
   local_tick =  local_tick + 1;
   clear_bit( intcon, T0IF );  //clear TMR0 overflow flag   
   if (global_tick > interval){
       #if DEBUG
	   //putst("\r\nTIME OUT! \r\n");
	   #endif
	   global_tick = 0;
   }
}
/*prescaler
  1 = 0.208ms
  2 = 0.417ms
  3 = 0.835ms
  4 = 1.665ms SIM_TIME = 60
  5 = 3.325ms
  6 = 6.65ms
  7 = 13.35ms
*/
void int_init(void)
{
	#if DEBUG
	prescaler = 4;
	#endif
	tmr0 = 0xff;
    //set_bit( STATUS, RP0 );
    option_reg = prescaler; //set prescaler to 1:256
    //set_tris_b( 0 );
    //clear_bit( STATUS, RP0 );
    //output_port_b( 0 );
}
void cur_average(void)
{
	int temp1;
	char ttt;
	current = 0;
	for (t = 0 ; t < num ; t++){
		//putst("AVG Current Value\r\n");
	    temp1 = 0x0000;
		temp1 = volt[2*t];
		temp1 = temp1 << 8;
		temp1 = temp1 + volt[2*t + 1];
		current = current + temp1;
		ttt = current >> 8; //DEBUG
		//putchhex(ttt);
		//putchhex(current);//DEBUG
		//putst("\r\n");
	}
	current = current / num;
}
void ad_check(void)
{	
	char ad_check_i;
    ad_check_i = read_bit(adcon0,P2);
	while(ad_check_i){
		ad_check_i = read_bit(adcon0,P2);
	}
}	

void adc_init(void)
{
	adcon1 = 0x80;//VDD is Ref, MSB 6 are 0
}

void ad_convert(char type)
{
	//#if DEBUG
    //putst("\r\nAD Converting!! \r\n");
    //#endif
    adcon0 = type;

	for (t=0 ; t < 10 ; t++)
		;;
	set_bit(adcon0,P2);
	ad_check();
    data_H = adresh;
	data_L = adresl;
}
void logo(void)
{
	putst(" ######################################\n\r" );
	putst(" #   B# : Battery Emulator Ver. 2.9   #\n\r" );
	putst(" #    Designed by Chulsung Park       #\n\r" );
    putst(" #    Advisor: Prof. Pai H. Chou      #\n\r" );
	putst(" ######################################\n\r" );
}

void run_led(void)
{
    clear_bit(trisc,P0);
    clear_bit(portc,P0);
}

void serial_init(void)
{
	spbrg=64;                   //CLK==20Mhz && BAUD==19200
	set_bit(txsta,BRGH);	    //Hight Speed data rate for sending
	clear_bit(txsta,SYNC);		//asynchronous
	set_bit(rcsta,SPEN);						//enable serial port pins
	set_bit(rcsta,CREN);						//enable reception
	clear_bit(rcsta,SREN);						//no effect
	clear_bit(pie1,TXIE);						//disable tx interrupts
	clear_bit(pie1,RCIE);						//disable rx interrupts
	clear_bit(txsta,TX9);						//8-bit transmission
	clear_bit(rcsta,RX9);						//8-bit reception
	clear_bit(txsta,TXEN);						//reset transmitter
	set_bit(txsta,TXEN);						//enable the transmitter
} 
char read_bit(char reg,char op)
{ 	
    char mask = 0x01;
    char read_bit_i;
    
	for (read_bit_i = 0; read_bit_i < op; read_bit_i++)
		mask = mask + mask;
	
    if ((reg & mask) == 0)
		return 0;
	else
		return 1;
}

void putch(char c)
{   
    char putch_i;
    putch_i = read_bit(pir1,TXIF);//TXIF);
	while(!putch_i)			//set when register is empty
	{ 
        clear_wdt();
		putch_i = read_bit(pir1,TXIF);
	}
	txreg = c;
	//DelayMs(1);
}

char getch(void)
{
    char i;
    i = read_bit(pir1,RCIF);
	while(!i)
	{
		clear_wdt();
	}
	return rcreg;
}

void putchhex(char c)
{
	char temp;

	temp=c;

	c=(c >> 4);
	
	if (c<10) c = c + 48; 
    else c = c + 55;
    
	putch(c);

	c=temp;

	c=(c & 0x0F);
	if (c<10) c = c + 48; 
    else c = c + 55;
	putch(c);
}

void putst(const char* str)
{
    char i = 0;
    while( str[i] != 0 )
        putch(str[i++]); 
}

void spi_init()
{
   set_bit(portc,P2);    //CS_ = 1  RC2 set 1
   clear_bit(trisc,P2);  //TRISC2 = 0; //ouput
   clear_bit(trisc,P5);  //TRISC5 = 0;
   clear_bit(trisc,P3);  //TRISC3 = 0;
   //CKE:CKP = 1:1,1:0,0:1,0:0
   //SSPSTAT
   //|SMP|CKE|D/A_| P | S | R/W_| UA| BF|
   //  1   1   1    0   0    0    0   0
   sspstat = 0xe0;       //SSPSTAT = 0xe0;
   //SSPCON
   //|WCOL|SSPOV|SSPEN|CKP|SSPM3|SSPM2|SSPM1|SSMP0|
   //  0     0     1    0    0     0     0     0
   sspcon = 0x20;        //SSPCON = 0x20;
   DelayUs(10);
   dac_out(0xf0,0x10);
}

void dac_out(char data_H, char data_L)
{
   #if DEBUG
   //putst("\r\nVOLTAGE OUT!! : ");
   //putchhex(data_H);
   //putst(" ");
   //putchhex(data_H);
   //putst(" \r\n");
   #endif
   clear_bit(portc,P2); //CS_ = 0;
   clear_bit(trisc,P2); //TRISC2 = 0;
   
   DelayUs(2);  

   sspbuf = data_H;

   DelayUs(1);   

   sspbuf = data_L;

   DelayUs(2);  

   set_bit(portc,P2); //CS_ = 1;
   clear_bit(trisc,P2); //TRISC2 = 0;
   DelayUs(1);
}

void write_creg(char regaddr, char regdata)
{

    portb = regaddr;  //cregaddr = regaddr;
    portd = regdata;  //cregdata = regdata;
    trisd = 0x00;     //tocreg;
    clear_bit(porte,P1); //IOW = 0;
    DelayUs(1);
    set_bit(porte,P1); //IOW = 1;
    trisd = 0xff;     //fromcreg;

}

char read_creg(char regaddr)
{

   trisd = 0xff; //fromcreg;

   portb = regaddr; //cregaddr = regaddr;
   clear_bit(porte,P0); //IOR = 0;
   DelayUs(1); 
   byte_read = portd; //byte_read = cregdata;  
   DelayUs(1);  
   set_bit(porte,P0); //IOR = 1;
   return(byte_read);

}

void regulator_init()
{
   clear_bit(portc,P0);//REGULATOR_ENABLE = 0;
   clear_bit(trisc,P0);//TRISC1 = 0;
}

void regulator(char status)
{
   if (status == TURNON){
		set_bit(portc,P0);
   }
   if (status == TURNOFF){
      	clear_bit(portc,P0);
   }
}

void currsensor(char status)
{
	clear_bit(trisb,P7);
   if (status == TURNON){
		clear_bit(portb,P7);
   }
   if (status == TURNOFF){
      	set_bit(portb,P7);
   }
}

void init_RTL8019AS()
{
   trisc = 0x90; //TRISC = 0x90;                       //|RX|TX|SDO|SDI|SCK|CS-|REG_ON|INT0|
				                       //  1  0  0   1   0   0    0     0
   trisb = 0xE0; //TRISB = 0xE0;                       // setup address lines
   portb = 0x00; //cregaddr = 0x00;                    // clear address lines
   trisd = 0xff; //fromcreg;                           // address lines = input
   trise = 0x00; //TRISE = 0x00;                       // setup IOW, IOR, RESET

   set_bit(porte,P0); //IOR = 1;                            // disable IOW
   set_bit(porte,P1); //IOW = 1;                            // disable IOR

   set_bit(porte,P2); //RESET = 1;                          // put NIC in reset
   DelayMs(2);                         // delay at least 1.6ms
   clear_bit(porte,P2); //RESET = 0;                          // disable reset line

   read_creg(RSTPORT);                 // read contents of reset port
   write_creg(RSTPORT,byte_read);      // do soft reset ?????? 5/26
   DelayMs(10);                        // give it time
   read_creg(ISR);                     // check for good soft reset
 
   if(byte_read < 0x80){
      while(1){
      putst("INIT FAILED\n\r");
      }
   }

   write_creg(CR,0x21);       //stop the NIC, abort DMA, page 0 START CMD: STP = 1
   DelayMs(2);               //make sure nothing is coming in or going out
   write_creg(DCR,0x18);    //0x58 not very important 
   write_creg(RBCR0,0x00);    //clear the DMA byte counters
   write_creg(RBCR1,0x00);

   write_creg(RCR,0x12);
   //write_creg(RCR,0x16);      //0x16 accept broadcast packets  VERY IMPORTANT!!!
   //write_creg(RCR,0x04);							  // 0001 0110	All packets with physical destination address are accepted
							  // multicast, less than 64bytes are accepted
 
   write_creg(TPSR,txstart);  //set transmit buffer start page  

   write_creg(TCR,0x02);      // was 0x02 01 means internal lookback

   write_creg(PSTART,rxstart);//set receive buffer start page

   write_creg(BNRY,rxstart);  //initialize the boundary  
   write_creg(PSTOP,rxstop);  //set receive buffer stop page  
   write_creg(CR,0x61);       //stop NIC and change control register page 
   DelayMs(2);
   write_creg(CURR,rxstart); 
 
   DelayMs(10);
   write_creg(CR,0x21);      //stop the NIC and go to home page 
   write_creg(DCR,dcrval);   //set FIFO threshold, enable Send Packet Command, 
   write_creg(CR,0x22);      //start NIC  

   write_creg(ISR,0xFF);     //clear interrupts
   write_creg(IMR,imrval);   //unmask interrupts 
   write_creg(TCR,tcrval);   //normal operation and enable CRC
   DelayMs(2000);
}

void send(char size)
{      
	   if (size < 51)
		   size = 51;
	   
       size =  size + HEADER_OFFSET;
	   
	   write_creg(CR,0x22);

	   write_creg(TPSR,0x40); //was txstart, 
       //This register sets the start page address of the packet to be transmitted.
	   write_creg(RSAR0,0x00);
	   write_creg(RSAR1,0x40);
       //These two registers set the start address of remote DMA.
       write_creg(ISR,0xFF);
	   write_creg(RBCR0,size); //write_creg(RBCR0,0x3c);
	   write_creg(RBCR1,0x00);

       //These two registers set the data byte counts of remote DMA
       write_creg(CR,0x12);  //was 0x12  Remote DMA write, changed to remodte reamd
      
       for(t = 0 ; t < size ; t++){
        write_creg(RSAR0,t);
        //write_creg(RDMAPORT,packet[t]);
        write_creg(0x10,packet[t]);
	   }

	   read_creg(ISR);
       while((byte_read&0x40)!= 0x40){
	       read_creg(ISR);
	   }

	   write_creg(TBCR0,size);  
	   write_creg(TBCR1,0x00);
	   //These two registers set the byte counts of the packet to be transmitted.
	   write_creg(CR,0x24);
	   
	   read_creg(ISR);
       while((byte_read&0x02)!=0x02){
		   read_creg(ISR);
	   }
	   
	   #if DEBUG
	   //putst("\r\n\r\nPacket has been sent!\n\r");
	   //putst("# of Bytes : ");
       //putchhex(size);
       //putst("\n\r"); 
	   //show_packet(size);
	   //putst("\n\r");
	   #endif
	   
}
void receive()
{
	  char i,temp,status;
	  //init_RTL8019AS();
	  write_creg(RBCR0,0x00);    //clear the DMA byte counters
	  write_creg(RBCR1,0x00);
	  
      //start the NIC
      write_creg(CR,0x22);
	  i = read_bit(portc,P4);
      //wait for a good packet
      while(!i){
      i = read_bit(portc,P4);
	  }
      //read the interrupt status register
      read_creg(ISR);
      //if the receive buffer has been overrun
      //if(bit_test(byte_read,OVW))
      //  overrun();

      //if the receive buffer holds a good packet
      temp = byte_read & 0x01;
      if(temp==0x01){
         get_packet();
		 //putst("PACKET");
		 //putst("\n\r");
	  }
	  write_creg(CR,0x62);
	  write_creg(CR,0x22);

/*
      //make sure the receive buffer ring is empty
      //if BNRY = CURR, the buffer is empty
         read_creg(BNRY);
         data_L = byte_read;
         
         read_creg(CURR);
         data_H = byte_read;
         write_creg(CR,0x22);
      //buffer is not empty.. get next packet
         if(data_L != data_H)
            get_packet();

      //reset the interrupt bits
*/
     write_creg(ISR,0xFF);
	 
}
char get_packet()
{
   char i,ofst,get_packet_temp;
   write_creg(CR,0x61);       //stop NIC and change control register page 
   write_creg(CURR,rxstart); 
   write_creg(CR,0x21);      //stop the NIC and go to home page 

   write_creg(RSAR0,0x00);
   write_creg(RSAR1,0x50); //was 0x40
   write_creg(ISR,0xFF);
   write_creg(RBCR0,0x5A); //5a MXIMUM_PACKET_SIZE
   write_creg(RBCR1,0x00);

   write_creg(CR,0x1A);
   /*
   for(t=0; t < PACKET_SIZE; t++)
   {
         write_creg(RSAR0,t);
         read_creg(0x10);
         packet[t] = byte_read;
   }
   */
   
   for(t = 0; t < DATA_OFFSET; t++)
   {
         write_creg(RSAR0,t);
         read_creg(0x10);
         
         if (t == TYPECODE_OFFSET)
		 {//10
					 typecode = byte_read;
			
					// putst("Packet was received! \n\r");
					//putst("Typecode : ");
					//putchhex(typecode);
					//putst("\r\n");
			
		  }
		  if (t == OPCODE_OFFSET)   //11
		  {
					 opcode = byte_read;
			
					 putst("Opcode : ");
					 putchhex(opcode);
					 putst("\r\n");
			
		   }
		   if (t == COUNT_OFFSET_OFFSET)
		   {
		   
					 packet_count = byte_read;
					// putst("# of Bytes : ");
					// putchhex(packet_count);
					// putst("\r\n");
		   } 
   }

   ofst = DATA_OFFSET + packet_count;
   
   for(t = DATA_OFFSET; t < ofst; t++)
   {   
		 write_creg(RSAR0,t);
		 
         read_creg(0x10);
         
         packet[t - DATA_OFFSET] = byte_read;
           
   }
   
   /*
   read_creg(ISR);
   
   while((byte_read & 0x40) == 0x40){
         read_creg(ISR);
   }
   */
     
   write_creg(ISR,0xFF);
  
   
   #if DEBUG
   show_packet(packet_count);
   //putst("\n\r"); 
   #endif
}

void DelayMs(int x)
{	
    int i;
	while(x--)
		for(i=0; i<330; i++)//1mS
			clear_wdt();
}

void DelayUs(int x)
{	
	while(x--)
//		for(i=0; i<1; i++)//9us
			clear_wdt();
}

void show_packet(char size)
{
   
   for(t=0;t < size;t++){
		//putchhex(packet[t]);
		//putst("  ");
	}
	//putst("\n\r");
}
void exchange_data(void)
{
	com_flag = 1;
	send_flag = 0;
	while ( com_flag ){
		#if DEBUG
		//putst("\r\nWaiting for receving CMD or DATA! \r\n");
		#endif
		receive_packet();
		if (send_flag == 1){
			send_packet();
			send_flag = 0;
		}
	}
}

void receive_packet(void)
{
	receive();

	send_recv = typecode & SEND_RECV_MASK;
	ack_noack = typecode & ACK_NOACK_MASK;
    data_type = typecode & DATA_TYPE_MASK;

	if (send_recv == SEND)
	{  
		
			if (data_type == MAX_TICK)
			{
					interval = packet[endian];

					//putst("MAX_TICK data has been Recevied \r\n");
					//putst("MAX_TICK : ");
					//putchhex(interval);
					//putst("\r\n");
			}
			if (data_type ==  VOLTAGE)
			{
					for (t = 0; t < packet_count ; t++)
						volt[t] = packet[t];			
			
					//putst("VOLTAGE data has been Recevied \r\n");
					//putst("VOLTAGE : \r\n");
					///for(t=0;t < packet_count;t++){
					//	putchhex(volt[t]);
					//	putst("  ");
					//}
					//putst("\n\r");
			 }
			 if (data_type == TIME)
			 {
					for (t = 0; t < packet_count ; t++)
						 time[t] = packet[t];
				    data_len = packet_count;
					
					//putst("TIME data has been Recevied \r\n");
					//putst("TIME : \r\n");
					//for(t=0;t < packet_count;t++){
					//	putchhex(time[t]);
					//	putst("  ");
					//}
					//putst("\n\r");
			  }								
			  if (data_type == PRESCALER)
			  {
					prescaler = packet[endian];	// for PC
					//prescaler = packet[1];  for mac
					
					//putst("PRESCALER data has been Recevied \r\n");
					//putst("PRESCALER : ");
					//putchhex(prescaler);
					//putst("\r\n");
			  }
			  
			  if (data_type == ENDIAN)
			  {
					endian = packet[0];	// for PC
					
					//putst("ENDIAN data has been Recevied \r\n");
					//putst("ENDIAN : ");
					//putchhex(endian);
					//putst("\r\n");
			  }
			  
			  if (data_type == VREFADC_INDEX_MASK)
			  {
					vref = packet[0];	// for PC
					
					if (vref == VREF_4)
					{
						adcon1 = 0x81;
						putst("\r\n Set the REF Voltage to 4.096V \r\n");
					}
	
					if (vref == VREF_5)
					{
		
					adcon1 = 0x80;//VDD is Ref, MSB 6 are 0
					putst("\r\n Set the REF Voltage to 5V \r\n");
					
					}
			  }
	}
	else 
	{
		#if DEBUG
		//putst("\r\nRECEIVE cmd has been interpreted!\r\n");
		#endif
		//send_flag = 1;
	}	
	if ( opcode == NOP )
	{
	}
	else
	{
		com_flag = 0;
	}	
	send_flag = 1;
}	


void send_packet(void)
{ 
		char temp;
		if (ack_noack == ACK){
			packet[MAC_ADDR_OFFSET + 0] = ACK; 
			packet[MAC_ADDR_OFFSET + 1] = 0x00;
			packet[MAC_ADDR_OFFSET + 2] = 0x00;
			send(0);
			#if DEBUG
			//putst("\r\nACK was Sent!\r\n");
			#endif
		}
		if (send_recv == RECV){
		/*
		temp = current >> 8;
		putchhex(temp);
		putchhex(current);
		putst("\r\n");
		*/
		if (data_type == CURR_AVG)
		{
					//#if DEBUG
					//current = 0x1234;
					//#endif
					temp = current >> 8;
					putchhex(temp);
					putchhex(current);
					putst("\r\n");
			
					packet[MAC_ADDR_OFFSET + 0] = CURR_AVG; 
					packet[MAC_ADDR_OFFSET + 1] = 0x00;
					packet[MAC_ADDR_OFFSET + 2] = 0x02;
				    if (endian == 0){
						packet[HEADER_OFFSET + 1] = current >> 8; //for PC
						packet[HEADER_OFFSET + 0] = current ;
					}else{
						packet[HEADER_OFFSET + 0] = current >> 8;// for MAC
						packet[HEADER_OFFSET + 1] = current ;
					}
					send(2);
					
					//putst("\r\nCURRENT_AVG was SENT!\r\n");
					//putchhex(data_type);
					//
		}			
		if (data_type == CURRENT)
		{
					temp = 2;// * interval;
					packet[MAC_ADDR_OFFSET + 0] = CURRENT; 
					packet[MAC_ADDR_OFFSET + 1] = 0x00;
					packet[MAC_ADDR_OFFSET + 2] = temp;
					for (t = 0 ; t < temp ; t++)
						packet[HEADER_OFFSET + t] = time[t];
					send(temp);
					
					//putst("\r\nMEASURE_CURRENT was SENT!\r\n");
					//putchhex(data_type);
					
		}
		if (data_type == VOLTAGE)
		{
					temp = 2;// * interval;
					packet[MAC_ADDR_OFFSET + 0] = VOLTAGE; 
					packet[MAC_ADDR_OFFSET + 1] = 0x00;
					packet[MAC_ADDR_OFFSET + 2] = temp;
					for (t = 0 ; t < temp ; t++)
						packet[HEADER_OFFSET + t] = volt[t];
					send(temp);
					
					//putst("\r\nMEASURE_VOLTAGE was SENT!\r\n");
					//putchhex(data_type);
				
		}
		}
}

